/*
 * Copyright (C) 2019 iopsys Software Solutions AB. All rights reserved.
 *
 * Author: <Kenneth.Johansson@iopsys.eu>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * version 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301 USA
 */
#ifndef _IMAGE_H_
#define _IMAGE_H_

#define HEADERS_SIZE 0x400

typedef enum {
        IMG_UNKNOWN,
        IMG_Y2,
        IMG_Y3,
} img_t;


struct img_header {
        char            *raw_buf;
        img_t           type;
        int             tot_size;       /* full size of image according to header */
        int             csum_size;       /* remove this number of bytes from end and do csum on rest */

};

struct range_data
{
        int src_offset;
        int src_len;
};

struct range_data adjust_range(int start,int end, int offset, int len);
struct img_header *img_init(int input);
void  img_print_hdr(struct img_header *hdr);

char *get_str_val(struct img_header *hdr, const char *key);
int   get_int_val(struct img_header *hdr, const char *key);


#endif /*_IMAGE_H_*/
